"use strict";

var utils = require("../utils")
var log = require("npmlog")
var cheerio = require('cheerio')

module.exports = function(defaultFuncs, api, ctx) {
  return function getUserID(params, callback) {
    if(!callback) {
      throw {error: "getUniqueID: need callback"};
    }
    const url = params.notification
    defaultFuncs
      .get(url, ctx.jar, {})
      //.then(utils.parseAndCheckLogin(ctx, defaultFuncs))
      .then(function(resData) {
        const r = /<!--((.+)FROM NOTIFICATIONS(.+))-->/g.exec(resData.body)
        const $ = cheerio.load(r[1])
        $('a[href="#"]').remove()
        const groupId = $('div[id^="group_mall_"]').attr('id').split('group_mall_')[1]
        const fbUserContent = $('.fbUserContent')
        const feeds = []
        for(var i = 0; i < fbUserContent.length; i++) {
          const time = fbUserContent.eq(i).find('.livetimestamp').data('utime')
          const message = fbUserContent.eq(i).find('.userContent').text()
          const name = fbUserContent.eq(i).find('.fwb').text()
          const id = fbUserContent.eq(i).find('a[data-hovercard^="/ajax/hovercard"]').attr('data-hovercard').split('&')[0].replace('/ajax/hovercard/user.php?id=', '')
          const alias = fbUserContent.eq(i).find('a[data-hovercard^="/ajax/hovercard"]')
            .attr('href')
            .replace('https://www.facebook.com/profile.php?id=', '')
            .replace('https://www.facebook.com/', '')
            .replace('&fref=nf','')
            .replace('?fref=nf','')
            .split('&')[0]
          const feedId = JSON.parse(fbUserContent.eq(i).parent().parent().attr('data-ft')).top_level_post_id
          const feed = {
            feedId,
            from: {
              id,
              name,
              alias,
            },
            createdAt: time * 1000,
            message,
            groupId,
          }
          feeds.push(feed)
        }
        return callback(null, feeds)
      })
      .catch(function(err) {
        log.error("getUniqueID", err);
        return callback(err);
      });
  };
};
