"use strict";

var utils = require("../utils");
var log = require("npmlog");

module.exports = function(defaultFuncs, api, ctx) {
  return function getUserID(params, callback) {
    if(!callback) {
      throw {error: "getUniqueID: need callback"};
    }
    const url = "https://www.facebook.com/groups/" + params.groupId + '/permalink/' + params.feedId
    defaultFuncs
      .get(url, ctx.jar, {})
      //.then(utils.parseAndCheckLogin(ctx, defaultFuncs))
      .then(function(resData) {
        if (params.commentId) {
          var matches = new RegExp(`id=${params.commentId}[^,]+,([^}]+)`, 'gi').exec(resData.body)
          var authorId = /author:"(\d+)"/.exec(matches[0])[1]
          matches = new RegExp(`{id:"${authorId}"[^}]+}`).exec(resData.body)
          var vanity = /vanity:"([^"]+)"/.exec(matches[0])[1]
          callback(null, {
            alias: vanity || authorId,
            id: authorId,
          })
        } else {
          var matchAlias = /https:\/\/www.facebook.com\/(profile\.php\?id=)*([^;?&]+)[^;?]+[;|?]fref=nf/.exec(resData.body)
          var matchUserId = /\\"actor_id\\":(\d+)/.exec(resData.body)
          if (resData.error) {
            throw resData;
          }
          callback(null, {
            alias: matchAlias[2],
            id: matchUserId[1],
          });
        }
      })
      .catch(function(err) {
        log.error("getUniqueID", err);
        return callback(err);
      });
  };
};
